// https://forex-station.com/viewtopic.php?p=1295478806#p1295478806 //button code1
// https://forex-station.com/viewtopic.php?p=1295478883#p1295478883 //button code2
#property indicator_chart_window

#property indicator_buffers 8
#property indicator_color1 clrLimeGreen
#property indicator_width1 4
#property indicator_color2 clrCrimson
#property indicator_width2 4
#property indicator_color3 clrGreen
#property indicator_width3 4
#property indicator_color4 clrMaroon
#property indicator_width4 4
#property indicator_color5 clrLimeGreen
#property indicator_color6 clrCrimson
#property indicator_color7 clrGreen
#property indicator_color8 clrMaroon

extern int           Sensitivity = 1;
extern color	      UpColor     = clrLimeGreen;	
extern color	      DnColor     = clrCrimson;
extern color	      UpColor1    = clrGreen;	
extern color	      DnColor1    = clrMaroon;

//Forex-Station button template start41; copy and paste
extern string             button_note1_         = "------------------------------";
extern int                btn_Subwindow         = 0;                               // What window to put the button on.  If <0, the button will use the same sub-window as the indicator.
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER;               // button corner on chart for anchoring
extern string             btn_text              = "NS";                            // a button name
extern string             btn_Font              = "Arial";                         // button font name
extern int                btn_FontSize          = 9;                               // button font size               
extern color              btn_text_ON_color     = clrLime;                         // ON color when the button is turned on
extern color              btn_text_OFF_color    = clrRed;                          // OFF color when the button is turned off
extern color              btn_background_color  = clrDimGray;                      // background color of the button
extern color              btn_border_color      = clrBlack;                        // border color the button
extern int                button_x              = 20;                              // x coordinate of the button     
extern int                button_y              = 25;                              // y coordinate of the button     
extern int                btn_Width             = 80;                              // button width
extern int                btn_Height            = 20;                              // button height
extern string             UniqueButtonID        = "NS";                            // Unique ID for each button        
extern string             button_note2          = "------------------------------";
bool show_data, recalc=false;
string IndicatorObjPrefix, buttonId;
//Forex-Station button template end41; copy and paste

int my_Chart_Scale = WRONG_VALUE, MAperiod02, MAperiod01;
double ExtBuffer01[], ExtBuffer02[], ExtBuffer03[], ExtBuffer04[], ExtBuffer05[], ExtBuffer06[], ExtBuffer07[], ExtBuffer08[];
//+------------------------------------------------------------------------------------------------------------------+
//Forex-Station button template start42; copy and paste
int OnInit()
{
   IndicatorDigits(Digits);
   IndicatorObjPrefix = "_" + btn_text + "_";
      
   // The leading "_" gives buttonId a *unique* prefix.  Furthermore, prepending the swin is usually unique unless >2+ of THIS indy are displayed in the SAME sub-window. (But, if >2 used, be sure to shift the buttonId position)
   buttonId = "_" + UniqueButtonID + IndicatorObjPrefix + "_BT_";
   if (ObjectFind(buttonId)<0) 
      createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);

   init2();

   show_data = ObjectGetInteger(0, buttonId, OBJPROP_STATE);
   
   if (show_data) ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_ON_color); 
   else ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_OFF_color);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
void createButton(string buttonID,string buttonText,int width2,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width2);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
      // Upon creation, set the initial state to "true" which is "on", so one will see the indicator by default
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, true);
}
//+------------------------------------------------------------------------------------------------------------------+
void OnDeinit(const int reason) 
{
   // If just changing a TF', the button need not be deleted, therefore the 'OBJPROP_STATE' is also preserved.
   if(reason != REASON_CHARTCHANGE) ObjectDelete(buttonId);
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   // If another indy on the same chart has enabled events for create/delete/mouse-move, just skip this events up front because they aren't
   //    needed, AND in the worst case, this indy might cause MT4 to hang!!  Skipping the events seems to help, along with other (major) changes to the code below.
   if(id==CHARTEVENT_OBJECT_CREATE || id==CHARTEVENT_OBJECT_DELETE) return; // This appears to make this indy compatible with other programs that enabled CHART_EVENT_OBJECT_CREATE and/or CHART_EVENT_OBJECT_DELETE
   if(id==CHARTEVENT_MOUSE_MOVE    || id==CHARTEVENT_MOUSE_WHEEL)   return; // If this, or another program, enabled mouse-events, these are not needed below, so skip it unless actually needed. 

   if (id==CHARTEVENT_OBJECT_CLICK && sparam == buttonId)
   {
      show_data = ObjectGetInteger(0, buttonId, OBJPROP_STATE);
      
      if (show_data)
      {
         ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_ON_color); 
         init2();
         // Is it a problem to call 'start()' ??  Possibly it makes no difference, but now calling "mystart()" instead of "start()"; and "start()" simply runs "mystart()", so should be same as before.
         recalc=true;
         mystart();
      }
      else
      {
         ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_OFF_color);
         for (int ForexStation2=0; ForexStation2<indicator_buffers; ForexStation2++)
              SetIndexStyle(ForexStation2,DRAW_NONE);
         deinit2();
      }
   }
   if(IsStopped())
   return;
   Buffers();
}
//Forex-Station button template end42; copy and paste
//+------------------------------------------------------------------------------------------------------------------+
int init2() {
   ObjectCreate("Close line", OBJ_HLINE, 0, Time[40], Close[0]);
   ObjectSet("Close line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("Close line", OBJPROP_COLOR, clrDimGray);
   SetIndexStyle(0, DRAW_HISTOGRAM, EMPTY, 4);
   SetIndexBuffer(0, ExtBuffer01);
   SetIndexStyle(1, DRAW_HISTOGRAM, EMPTY, 4);
   SetIndexBuffer(1, ExtBuffer02);
   SetIndexStyle(2, DRAW_HISTOGRAM, EMPTY, 4);
   SetIndexBuffer(2, ExtBuffer03);
   SetIndexStyle(3, DRAW_HISTOGRAM, EMPTY, 4);
   SetIndexBuffer(3, ExtBuffer04);
   SetIndexStyle(4, DRAW_HISTOGRAM, EMPTY, 0);
   SetIndexBuffer(4, ExtBuffer05);
   SetIndexStyle(5, DRAW_HISTOGRAM, EMPTY, 0);
   SetIndexBuffer(5, ExtBuffer06);
   SetIndexStyle(6, DRAW_HISTOGRAM, EMPTY, 0);
   SetIndexBuffer(6, ExtBuffer07);
   SetIndexStyle(7, DRAW_HISTOGRAM, EMPTY, 0);
   SetIndexBuffer(7, ExtBuffer08);
   IndicatorShortName("NS");
   return (0);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit2() {
   ObjectDelete("Close line");
   Comment("");
   return (0);
}
//+------------------------------------------------------------------------------------------------------------------+
int start() {return(mystart()); }
//+------------------------------------------------------------------------------------------------------------------+
int mystart()
  {
   if (show_data)
      {
        int CountedBars=IndicatorCounted();
        if(recalc) 
        {
           // If a button goes from off-to-on, everything must be recalculated.  The 'recalc' variable is used as a trigger to do this.
           CountedBars = 0;
           recalc=false;
        }
   double myCCI1, myCCI2;
   int limit;
   ObjectMove("Close line", 0, Time[20], Close[0]);
   if (Sensitivity == 1)
    {
      MAperiod01 = 5;
      MAperiod02 = 14;
   }
   if (Sensitivity == 0 || Sensitivity == 2 || Sensitivity > 3)
    {
      MAperiod01 = 14;
      MAperiod02 = 50;
   }
   if (Sensitivity == 3)
    {
      MAperiod01 = 89;
      MAperiod02 = 200;
   }
//   if (Bars <= 15) return (0);
   if (CountedBars < 1) {
      for (int SEFC = 1; SEFC <= 15; SEFC++) {
         ExtBuffer01[Bars - SEFC] = 0.0;
         ExtBuffer03[Bars - SEFC] = 0.0;
         ExtBuffer02[Bars - SEFC] = 0.0;
         ExtBuffer04[Bars - SEFC] = 0.0;
         ExtBuffer05[Bars - SEFC] = 0.0;
         ExtBuffer07[Bars - SEFC] = 0.0;
         ExtBuffer06[Bars - SEFC] = 0.0;
         ExtBuffer08[Bars - SEFC] = 0.0;
      }
   }
   if (CountedBars > 0) limit = Bars - CountedBars;
   if (CountedBars == 0) limit = Bars - 15 - 1;
   for (SEFC = limit; SEFC >= 0; SEFC--) {
      myCCI1 = iCCI(NULL, 0, MAperiod01, PRICE_TYPICAL, SEFC);
      myCCI2 = iCCI(NULL, 0, MAperiod02, PRICE_TYPICAL, SEFC);
      ExtBuffer01[SEFC] = EMPTY_VALUE;
      ExtBuffer03[SEFC] = EMPTY_VALUE;
      ExtBuffer02[SEFC] = EMPTY_VALUE;
      ExtBuffer04[SEFC] = EMPTY_VALUE;
      ExtBuffer05[SEFC] = EMPTY_VALUE;
      ExtBuffer07[SEFC] = EMPTY_VALUE;
      ExtBuffer06[SEFC] = EMPTY_VALUE;
      ExtBuffer08[SEFC] = EMPTY_VALUE;
      if (myCCI1 >= 0.0 && myCCI2 >= 0.0) {
         ExtBuffer01[SEFC] = MathMax(Open[SEFC], Close[SEFC]);
         ExtBuffer02[SEFC] = MathMin(Open[SEFC], Close[SEFC]);
         ExtBuffer05[SEFC] = High[SEFC];
         ExtBuffer06[SEFC] = Low[SEFC];
      } else {
         if (myCCI2 >= 0.0 && myCCI1 < 0.0) {
            ExtBuffer03[SEFC] = MathMax(Open[SEFC], Close[SEFC]);
            ExtBuffer04[SEFC] = MathMin(Open[SEFC], Close[SEFC]);
            ExtBuffer07[SEFC] = High[SEFC];
            ExtBuffer08[SEFC] = Low[SEFC];
         } else {
            if (myCCI1 < 0.0 && myCCI2 < 0.0) {
               ExtBuffer02[SEFC] = MathMax(Open[SEFC], Close[SEFC]);
               ExtBuffer01[SEFC] = MathMin(Open[SEFC], Close[SEFC]);
               ExtBuffer06[SEFC] = High[SEFC];
               ExtBuffer05[SEFC] = Low[SEFC];
            } else {
               if (myCCI2 < 0.0 && myCCI1 > 0.0) {
                  ExtBuffer04[SEFC] = MathMax(Open[SEFC], Close[SEFC]);
                  ExtBuffer03[SEFC] = MathMin(Open[SEFC], Close[SEFC]);
                  ExtBuffer08[SEFC] = High[SEFC];
                  ExtBuffer07[SEFC] = Low[SEFC];
               }
            }
         }
      }
   }
      } //if (show_data)  
   return (0);
}
//+------------------------------------------------------------------------------------------------------------------+
void Buffers()
  {
   int Chart_Scale = int(ChartGetInteger(0, CHART_SCALE));
   if(my_Chart_Scale == Chart_Scale)
      return;
   my_Chart_Scale = Chart_Scale;
   int Width = 0;
   switch(Chart_Scale)
     {
      case 0:
         Width = 1;
         break;
      case 1:
         Width = 1;
         break;
      case 2:
         Width = 2;
         break;
      case 3:
         Width = 4;
         break;
      case 4:
         Width = 6;
         break;
      case 5:
         Width = 14;
         break;
     }  
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, Width, UpColor);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, Width, DnColor);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, Width, UpColor1);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID, Width, DnColor1);
   ChartRedraw();
  }
//+------------------------------------------------------------------------------------------------------------------+
